------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Interfaces.C;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects.Mime_Data_Utilities;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt_Ada.Internals.Objects.Abstract_Item_Model_Proxies is

   procedure buddy_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Returns : not null access Qt4.Model_Indices.Internals.QModelIndex);
      pragma Import (C, buddy_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_buddy_0_virtual");

   function canFetchMore_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool;
      pragma Import (C, canFetchMore_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_canFetchMore_0_virtual");

   function columnCount_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.Q_Integer;
      pragma Import (C, columnCount_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_columnCount_0_virtual");

   function dropMimeData_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Data : access Qt_Ada.Internals.Objects.QObject;
     Action : Qt4.Drop_Action;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool;
      pragma Import (C, dropMimeData_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_dropMimeData_0_virtual");

   procedure fetchMore_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex);
      pragma Import (C, fetchMore_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_fetchMore_0_virtual");

   function hasChildren_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool;
      pragma Import (C, hasChildren_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_hasChildren_0_virtual");

   function hasIndex_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool;
      pragma Import (C, hasIndex_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_hasIndex_0_virtual");

   procedure index_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Returns : not null access Qt4.Model_Indices.Internals.QModelIndex);
      pragma Import (C, index_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_index_0_virtual");

   function insertColumns_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool;
      pragma Import (C, insertColumns_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_insertColumns_0_virtual");

   function insertRows_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool;
      pragma Import (C, insertRows_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_insertRows_0_virtual");

   function mimeData_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Indexes : not null access constant Qt4.Model_Index_Lists.Thin.QModelIndexList)
       return access Qt_Ada.Internals.Objects.QObject;
      pragma Import (C, mimeData_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_mimeData_0_virtual");

   procedure mimeTypes_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.String_Lists.Internals.QStringList);
      pragma Import (C, mimeTypes_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_mimeTypes_0_virtual");

   procedure parent_1_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Child : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Returns : not null access Qt4.Model_Indices.Internals.QModelIndex);
      pragma Import (C, parent_1_virtual,
                     "__Qt4Ada_QAbstractItemModel_parent_1_virtual");

   function removeColumns_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool;
      pragma Import (C, removeColumns_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_removeColumns_0_virtual");

   function removeRows_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool;
      pragma Import (C, removeRows_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_removeRows_0_virtual");

   function rowCount_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.Q_Integer;
      pragma Import (C, rowCount_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_rowCount_0_virtual");

   procedure span_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Returns : not null access Qt4.Sizes.Internals.QSize);
      pragma Import (C, span_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_span_0_virtual");

   procedure revert_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
      pragma Import (C, revert_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_revert_0_virtual");

   function submit_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
      pragma Import (C, submit_0_virtual,
                     "__Qt4Ada_QAbstractItemModel_submit_0_virtual");

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;

   function data_virtual
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex;
     Role  : Interfaces.C.int)
       return Qt4.Variants.Internals.QVariant_Access;
   pragma Import (C, data_virtual, "__Qt4Ada_QAbstractItemModel_data_virtual");

   function flags_virtual
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.Item_Flags;
   pragma Import
    (C, flags_virtual, "__Qt4Ada_QAbstractItemModel_flags_virtual");

   function headerData_virtual
    (Self        : not null access Qt_Ada.Internals.Objects.QObject;
     Section     : Interfaces.C.int;
     Orientation : Qt4.Orientations;
     Role        : Interfaces.C.int)
       return Qt4.Variants.Internals.QVariant_Access;
   pragma Import
    (C, headerData_virtual, "__Qt4Ada_QAbstractItemModel_headerData_virtual");

   function setData_virtual
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex;
     Value : not null access Qt4.Variants.Internals.QVariant;
     Role  : Interfaces.C.int)
       return Qt4.bool;
   pragma Import
    (C, setData_virtual, "__Qt4Ada_QAbstractItemModel_setData_virtual");

   function setHeaderData_virtual
    (Self    : not null access Qt_Ada.Internals.Objects.QObject;
     Section : Interfaces.C.int;
     Orient  : Qt4.Orientation;
     Value   : not null access Qt4.Variants.Internals.QVariant;
     Role    : Interfaces.C.int)
       return Qt4.bool;
   pragma Import (C,
                  setHeaderData_virtual,
                  "__Qt4Ada_QAbstractItemModel_setHeaderData_virtual");

   ----------
   -- Data --
   ----------

   overriding
   function Data
    (Self  : not null access Q_Abstract_Item_Model_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Role  : Qt4.Item_Data_Role := Qt4.Display_Role)
       return Qt4.Variants.Q_Variant
   is
   begin
      return
        Qt4.Variants.Internals.Create_Wrapper
         (data_virtual
           (Self.QObject_View,
            Qt4.Model_Indices.Internals.QModelIndex_View (Index),
            Interfaces.C.int (Role)));
   end Data;

   -----------
   -- Flags --
   -----------

   overriding
   function Flags
    (Self  : not null access constant Q_Abstract_Item_Model_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Item_Flags
   is
   begin
      return flags_virtual
              (Self.QObject_View,
               Qt4.Model_Indices.Internals.QModelIndex_View (Index));
   end Flags;

   -----------------
   -- Header_Data --
   -----------------

   overriding
   function Header_Data
    (Self        : not null access Q_Abstract_Item_Model_Proxy;
     Section     : Qt4.Q_Integer;
     Orientation : Qt4.Orientations;
     Role        : Qt4.Item_Data_Role := Qt4.Display_Role)
     return Qt4.Variants.Q_Variant
   is
   begin
      return Qt4.Variants.Internals.Create_Wrapper
             (headerData_virtual
               (Self.QObject_View,
                Interfaces.C.int (Section),
                Orientation,
                Interfaces.C.int (Role)));
   end Header_Data;

   --------------
   -- Set_Data --
   --------------

   overriding
   function Set_Data
    (Self  : not null access Q_Abstract_Item_Model_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Value : Qt4.Variants.Q_Variant;
     Role  : Qt4.Item_Data_Role := Qt4.Edit_Role)
       return Boolean
   is
   begin
      return Qt4.To_Boolean
              (setData_virtual
               (Self.QObject_View,
                Qt4.Model_Indices.Internals.QModelIndex_View (Index),
                Qt4.Variants.Internals.QVariant_View (Value),
                Interfaces.C.int (Role)));
   end Set_Data;

   ---------------------
   -- Set_Header_Data --
   ---------------------

   function Set_Header_Data
    (Self    : not null access Q_Abstract_Item_Model_Proxy;
     Section : Qt4.Q_Integer;
     Orient  : Qt4.Orientation;
     Value   : Qt4.Variants.Q_Variant;
     Role    : Qt4.Item_Data_Role := Qt4.Edit_Role)
       return Boolean
   is
   begin
      return Qt4.To_Boolean
              (setHeaderData_virtual
                (Self.QObject_View,
                 Interfaces.C.int (Section),
                 Orient,
                 Qt4.Variants.Internals.QVariant_View (Value),
                 Interfaces.C.int (Role)));
   end Set_Header_Data;

   pragma Style_Checks ("N");

   -----------
   -- Buddy --
   -----------

   function Buddy
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
   is
      Returns : Qt4.Model_Indices.Q_Model_Index;

   begin
      buddy_0_virtual
       (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Index),
        Qt4.Model_Indices.Internals.QModelIndex_View (Returns));

      return Returns;
   end Buddy;

   --------------------
   -- Can_Fetch_More --
   --------------------

   function Can_Fetch_More
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (canFetchMore_0_virtual
           (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
            Qt4.Model_Indices.Internals.QModelIndex_View (Parent)));
   end Can_Fetch_More;

   ------------------
   -- Column_Count --
   ------------------

   function Column_Count
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Q_Integer
   is
   begin
      return
        columnCount_0_virtual
         (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
          Qt4.Model_Indices.Internals.QModelIndex_View (Parent));
   end Column_Count;

   --------------------
   -- Drop_Mime_Data --
   --------------------

   function Drop_Mime_Data
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Data : access Qt4.Mime_Datas.Q_Mime_Data'Class;
     Action : Qt4.Drop_Action;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (dropMimeData_0_virtual
           (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
            Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject (Data),
            Action,
            Row,
            Column,
            Qt4.Model_Indices.Internals.QModelIndex_View (Parent)));
   end Drop_Mime_Data;

   ----------------
   -- Fetch_More --
   ----------------

   procedure Fetch_More
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Parent : Qt4.Model_Indices.Q_Model_Index)
   is
   begin
      fetchMore_0_virtual
       (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent));
   end Fetch_More;

   ------------------
   -- Has_Children --
   ------------------

   function Has_Children
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasChildren_0_virtual
           (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
            Qt4.Model_Indices.Internals.QModelIndex_View (Parent)));
   end Has_Children;

   ---------------
   -- Has_Index --
   ---------------

   function Has_Index
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasIndex_0_virtual
           (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
            Row,
            Column,
            Qt4.Model_Indices.Internals.QModelIndex_View (Parent)));
   end Has_Index;

   -----------
   -- Index --
   -----------

   function Index
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
   is
      Returns : Qt4.Model_Indices.Q_Model_Index;

   begin
      index_0_virtual
       (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
        Row,
        Column,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent),
        Qt4.Model_Indices.Internals.QModelIndex_View (Returns));

      return Returns;
   end Index;

   --------------------
   -- Insert_Columns --
   --------------------

   function Insert_Columns
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (insertColumns_0_virtual
           (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
            Column,
            Count,
            Qt4.Model_Indices.Internals.QModelIndex_View (Parent)));
   end Insert_Columns;

   -----------------
   -- Insert_Rows --
   -----------------

   function Insert_Rows
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (insertRows_0_virtual
           (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
            Row,
            Count,
            Qt4.Model_Indices.Internals.QModelIndex_View (Parent)));
   end Insert_Rows;

   ---------------
   -- Mime_Data --
   ---------------

   function Mime_Data
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Indexes : Qt4.Model_Index_Lists.Q_Model_Index_List)
       return access Qt4.Mime_Datas.Q_Mime_Data'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Mime_Data_Utilities.Corresponding_Q_Mime_Data
         (mimeData_0_virtual
           (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
            Qt4.Model_Index_Lists.Internals.QModelIndexList_View (Indexes)));
   end Mime_Data;

   ----------------
   -- Mime_Types --
   ----------------

   function Mime_Types
    (Self : not null access constant Q_Abstract_Item_Model_Proxy)
       return Qt4.String_Lists.Q_String_List
   is
      Returns : Qt4.String_Lists.Q_String_List;

   begin
      mimeTypes_0_virtual
       (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
        Qt4.String_Lists.Internals.QStringList_View (Returns));

      return Returns;
   end Mime_Types;

   ------------
   -- Parent --
   ------------

   function Parent
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Child : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
   is
      Returns : Qt4.Model_Indices.Q_Model_Index;

   begin
      parent_1_virtual
       (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Child),
        Qt4.Model_Indices.Internals.QModelIndex_View (Returns));

      return Returns;
   end Parent;

   --------------------
   -- Remove_Columns --
   --------------------

   function Remove_Columns
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (removeColumns_0_virtual
           (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
            Column,
            Count,
            Qt4.Model_Indices.Internals.QModelIndex_View (Parent)));
   end Remove_Columns;

   -----------------
   -- Remove_Rows --
   -----------------

   function Remove_Rows
    (Self : not null access Q_Abstract_Item_Model_Proxy;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (removeRows_0_virtual
           (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
            Row,
            Count,
            Qt4.Model_Indices.Internals.QModelIndex_View (Parent)));
   end Remove_Rows;

   ---------------
   -- Row_Count --
   ---------------

   function Row_Count
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Q_Integer
   is
   begin
      return
        rowCount_0_virtual
         (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
          Qt4.Model_Indices.Internals.QModelIndex_View (Parent));
   end Row_Count;

   ----------
   -- Span --
   ----------

   function Span
    (Self : not null access constant Q_Abstract_Item_Model_Proxy;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      span_0_virtual
       (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Index),
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Span;

   ------------
   -- Revert --
   ------------

   procedure Revert
    (Self : not null access Q_Abstract_Item_Model_Proxy)
   is
   begin
      revert_0_virtual
       (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View);
   end Revert;

   ------------
   -- Submit --
   ------------

   function Submit
    (Self : not null access Q_Abstract_Item_Model_Proxy)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (submit_0_virtual
           (Q_Abstract_Item_Model_Proxy'Class (Self.all).QObject_View));
   end Submit;

   type Q_Abstract_Item_Model_Proxy_Access is
     access all Q_Abstract_Item_Model_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access
   is
      Self : constant not null Q_Abstract_Item_Model_Proxy_Access
        := new Q_Abstract_Item_Model_Proxy;

   begin
      Qt_Ada.Internals.Objects.Initialize (Self, Object);

      return Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Object_Registry.Register_Proxy
    ("QAbstractItemModel", Create'Access);
end Qt_Ada.Internals.Objects.Abstract_Item_Model_Proxies;
